clear all
close all
clc
format long

y = 3.22;

%% The following two are correspondences 
PixCoor = 768; %number of pixels
PhyLen = 584; %mm
%%
thetaA = 67.976*pi/180;
thetaB = 77.802*pi/180;


y_512 = 739;
% %% Data loading
load('.\Data\SDF_2019\CellLine\cellLine_orig.mat');

startFrame = 3520;
endFrame = 3530;

for i = startFrame:1:endFrame
    tempCell = cellLine{i, 1};
    for j = 1:1:size(tempCell, 2)
        if size(tempCell(1,j).line,1) ~= 0
            x1 = tempCell(1, j).line(1).x;
            x2 = tempCell(1, j).line(2).x;
            minX1 = min(x1);
            maxX1 = max(x1);
            minX2 = min(x2);
            maxX2 = max(x2);
            minX = max(minX1, minX2);
            maxX = min(maxX1, maxX2);

            stepX = minX:1:maxX;
            y1 = tempCell(1, j).line(1).para(1)*stepX + tempCell(1, j).line(1).para(2);
            y2 = tempCell(1, j).line(2).para(1)*stepX + tempCell(1, j).line(2).para(2);
            diff = abs(y1-y2) ;
            for k = 1:1:length(stepX)
                pys_y(k) = PhyLen*y/(PhyLen-((PixCoor-(minX+(k-1)))/tan(thetaA)+(PixCoor-(minX+(k-1)))/tan(thetaB)))*diff(k);            end
            Pys(1,j).diff = diff;
            Pys(1,j).pys_y = pys_y;
        end
    end
    PysCell{i,1} = Pys;
end


%% Visualisation
color = PlotColor(); % color matrix
for i = startFrame:1:endFrame
    figure(i)
    buffDist = [];
    buffTempX = [];
    tempCell = PysCell{i,1};
    for j = 1:1:size(tempCell, 2)
        tempDist = tempCell(1,j).pys_y ;
        buffDist = [buffDist tempDist];
        tempX = 1:1:length(tempDist);
        buffTempX = [buffTempX tempX];
    end
    
% DBscan Parameters
epsilon = 25; % max distance between two points to be considered in one cluster  5
MinPts = 1000; % Minimum number of points in one cluster  8

m_c_id = DBSCAN(buffDist',epsilon,MinPts);
N_g = max(m_c_id);

flag = [];
for h = 1:1:N_g
    flag(h) = length(find(m_c_id == h));
end

maxindex = find(flag == max(flag));
buffDist = buffDist(1,find(m_c_id == maxindex));


buffTempX = linspace(1,length(buffDist),length(buffDist));
 %%
    plot(buffTempX, buffDist,'color','y',...
            'Linewidth',0.5); 
    MEAN(i) = mean(buffDist);
    STD(i) = std(buffDist,0);
    RMSE(i) = std(buffDist,1);
    ERROR(i) = 165 - MEAN(i);
end

